Bug 457702 - udev creates hwclock race in system with multiple RTC devices
udev creates hwclock race in system with multiple RTC devices
Status: CLOSED CANTFIX
Product: Fedora
Classification: Fedora
Component: initscripts (Show other bugs)
9
x86_64 Linux
medium Severity medium
: ---
: ---
Assigned To: Bill Nottingham
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-08-03 22:39 EDT by W. Price
Modified: 2014-03-16 23:15 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-06-10 11:51:05 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description W. Price 2008-08-03 22:39:22 EDT
In a system with multiple RTC devices, udev executes '/sbin/hwclock --hctosys' multiple times in such a way that it creates a race condition.  (System load > 2.9 on a dual-core Athlon).

Observed behavior is a hang at udev startup (eventually times out and boot continues with udev still working in the background).  Once logged in, executing 'top' reveals at least two 'hwclock' processes using up all available processor time.  Prior to killing all 'hwclock' instances, system response is very sluggish.

NOTE: This may be related to specific hardware and/or the DVB subsystem; the additional RTCs in the affected system are on two similar DVB capture cards:
- Dvico FusionHDTV 5 Gold (pci)
- Dvico FusionHDTV 5 Express (pci-e)

This problem was not noticed on Fedora 7 with a pre-2.6.24 kernel, but that's probably because the PCI-E card was not supported nor initialized under that kernel.

This problem was observed using the Fedora 9 release kernel as well as a fully updated system as of 03 Aug 2008 (kernel 2.6.25.11-97.fc9.x86_64).


Version-Release: Fedora 9 (Sulphur)

How reproducible: 100%, under above conditions

Additional info:

Replacing '/etc/udev/rules.d/88-clock.rules' with the following successfully prevented the 'hwclock' race condition:

# First RTC
ACTION=="add", SUBSYSTEM=="rtc", NAME=="rtc0", RUN+="/sbin/hwclock --hctosys --rtc=/dev/%k"
ACTION=="add", MAJOR==10, MINOR==135, NAME=="rtc0", RUN+="/sbin/hwclock --hctosys --rtc=/dev/%k"

# Additional RTCs
ACTION=="add", SUBSYSTEM=="rtc", NAME=="rtc[1-9][0-9]*"
ACTION=="add", MAJOR==10, MINOR==135, NAME=="rtc[1-9][0-9]*"


NOTE:
This is my first time troubleshooting udev and I don't know enough about the uses of the RTC subsystem to know if this change would cause adverse effects.
Comment 1 Harald Hoyer 2008-08-04 12:24:14 EDT
$ rpm -qf /etc/udev/rules.d/88-clock.rules
initscripts-8.76.2-1.x86_64
Comment 2 Bill Nottingham 2008-08-04 12:30:03 EDT
What are the hung processes actually doing (check with strace, etc.)

Considering that they're supposed to be called to operate on different devices, I'm not sure why they would fail in that way.b
Comment 3 Bug Zapper 2009-06-09 22:21:58 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 4 Bill Nottingham 2009-06-10 11:51:05 EDT
Closing, no response.

Note You need to log in before you can comment on or make changes to this bug.